#include "SAB.h"

SAB::SAB() : _screenConfig(128, 64, 0x3C), _display(_screenConfig.getWidth(), _screenConfig.getHeight(), &Wire), _screenManager(_display), _rtc(), _rtcManager(_rtc), _error(0)
{ 
  Serial.begin(9600);
  delay(200);
  
  //We initialize the pins for the  I2C communication
  Wire.begin(_pinConfig.getI2C_sda(), _pinConfig.getI2C_scl());
  if(!_rtc.begin()) _error |= RTC_BEGIN_ERR;
  if(!_display.begin(SSD1306_SWITCHCAPVCC, _screenConfig.getAddress())) _error |= DISP_BEGIN_ERR;
}

SAB::SAB(const PinMapping pinConfig, const ScreenConfig screenConfig) : _pinConfig(pinConfig), _screenConfig(screenConfig), _display(_screenConfig.getWidth(), _screenConfig.getHeight(), &Wire), _screenManager(_display), _rtc(), _rtcManager(_rtc), _error(0)
{
  Serial.begin(9600);
  delay(200);
  
  //We initialize the pins for the  I2C communication
  Wire.begin(_pinConfig.getI2C_sda(), _pinConfig.getI2C_scl());
  if(!_rtc.begin()) _error |= RTC_BEGIN_ERR;
  if(!_display.begin(SSD1306_SWITCHCAPVCC, _screenConfig.getAddress())) _error |= DISP_BEGIN_ERR;
}

ScreenManager& SAB::getScreenManager()
{
  return _screenManager;
}

const RtcManager& SAB::getRtcManager() const
{
  return _rtcManager;
}

ScreenConfig SAB::getScreenConfig() const
{
  return _screenConfig;
}

PinMapping SAB::getPinConfig() const
{
  return _pinConfig;
}

unsigned char SAB::getError() const
{
  return _error;
}

