#ifndef SAB_H
#define SAB_H
#include "PinMapping.h"
#include "ScreenConfig.h"
#include "RtcManager.h"
#include "ScreenManager.h"
#include <Adafruit_SSD1306.h>
#include <RTClib.h>

class SAB
{
  public:
    SAB();
    SAB(const PinMapping pinConfig, const ScreenConfig screenConfig);
    
    ScreenManager& getScreenManager();
    const RtcManager& getRtcManager() const;
    ScreenConfig getScreenConfig() const;
    PinMapping getPinConfig() const;
    
    unsigned char getError() const;
  private:
    const PinMapping _pinConfig;
    const ScreenConfig _screenConfig;
    
    Adafruit_SSD1306 _display;
    ScreenManager _screenManager;
    const RTC_DS3231 _rtc;
    const RtcManager _rtcManager;

    unsigned char _error;
};

#endif //SAB_H
