#include "ScreenManager.h"

ScreenManager::ScreenManager(Adafruit_SSD1306 &display) : _displayRef(display)
{  
  _viewLinkedList = (ViewLinkedList) createEmptyList();
}

boolean ScreenManager::addView(boolean (*viewLogicFunction)(Adafruit_SSD1306&, void*), void *pData, const unsigned char UID)
{
  ViewLink viewLink ={viewLogicFunction, pData, UID, NULL};
  addNewLinkAtTheEnd(&_viewLinkedList, viewLink);
}

void *ScreenManager::createEmptyList()
{
  return NULL;
}

boolean ScreenManager::addNewLinkAtTheEnd(ViewLinkedList *viewLinkedList, ViewLink viewLink)
{
  ViewLink *newViewLink = (ViewLink*) malloc(sizeof(ViewLink));
  if(newViewLink == NULL)
  {
    _error |= MALLOC_ERR;
    return false;
  }
  
  //Because of the const member
  memcpy(newViewLink, &viewLink, sizeof(*newViewLink));

  /*TO DO*/
  
  return true;
}

boolean ScreenManager::isListEmpty(ViewLinkedList viewLinkedList)
{
  return viewLinkedList == NULL;
}

unsigned char ScreenManager::getError() const
{
  return _error;
}

void ScreenManager::iterateThroughList()
{
  Serial.println("Lets go through");
  while(!isListEmpty(_viewLinkedList))
  {
    Serial.print("UID : ");Serial.println(_viewLinkedList->UID);
    _viewLinkedList = _viewLinkedList->next;
  }
}


