#ifndef SCREENMANAGER_H
#define SCREENMANAGER_H
#include "definition.h"
#include <Adafruit_SSD1306.h>

class ScreenManager
{
  friend class SAB;
  public:
    boolean addView(boolean (*viewLogicFunction)(Adafruit_SSD1306&, void*), void *pData, const unsigned char UID);
    unsigned char getError() const;

    
    void iterateThroughList();
    
  protected:
    ScreenManager(Adafruit_SSD1306 &display);
  private:
    void *createEmptyList();
    boolean addNewLinkAtTheEnd(ViewLinkedList *viewLinkedList, ViewLink viewLink);
    boolean isListEmpty(ViewLinkedList viewLinkedList);
    
    Adafruit_SSD1306 &_displayRef;
    ViewLinkedList _viewLinkedList;
    unsigned char _error;
};

#endif //SCREENMANAGER_H
