#ifndef DEFINITION_H
#define DEFINITION_H

#include <Adafruit_SSD1306.h>
#include <Arduino.h>

enum Pin {  GPIO_0 = 0,
            GPIO_1_TX = 1,
            GPIO_2 = 2,
            GPIO_3_RX = 3,
            GPIO_4_SDA = 4,
            GPIO_5_SCL = 5,
            GPIO_10 = 10,
            GPIO_12_MISO = 12,
            GPIO_13_MOSI = 13,
            GPIO_14_CLK = 14,
            GPIO_15 = 15,
            GPIO_16 = 16,
            ADC = A0,
            DEFAULT_PIN = -1};
            
#define RTC_BEGIN_ERR   B00000001
#define DISP_BEGIN_ERR  B00000010

#define MALLOC_ERR   B00000001

//Data structure for the view handling
typedef struct viewLink{
  boolean (*viewLogicFunction)(Adafruit_SSD1306&, void*);
  void *pData;
  const unsigned char UID;
  
  viewLink *next;
} ViewLink, *ViewLinkedList;
            

#endif //DEFINITION_H
